unit hiBitBtn;

interface

uses Windows,Kol,Share,Win,messages;

{$I share.inc}

type
  THIBitBtn = class(THIWin)
   private
     FBmp:PBitmap;
     FX,FY:integer;

     procedure SetCaption(const Value:string);
     procedure SetFlat(Value:boolean);
     function _OnDraw( Sender: PControl; BtnState: Integer ): Boolean;
     procedure _OnClick(Obj:PObj);
     procedure SetBitmap(Value:HBITMAP);
     //function  _onMessage( var Msg: TMsg; var Rslt: Integer ): Boolean; //override;
   public
     _event_onClick:THI_Event;
     _prop_Data:TData;
     _prop_Frame:byte;
     _prop_FrameColor:TColor;
     _data_Bitmap:THI_Event;

    constructor Create(Parent:PControl);
    procedure _work_doBitmap(var _Data:TData; Index:word);
    procedure _work_doCaption(var _Data:TData; Index:word);
    property _prop_Caption:string write SetCaption;
    property _prop_Bitmap:HBITMAP write SetBitmap;
    property _prop_Flat:boolean write SetFlat;

  end;

implementation

constructor THIBitBtn.Create;
begin
   inherited Create(Parent);

   FBmp := NewBitmap(0,0);
   Control := NewBitBtn(Parent,'BitBtn',[],glyphLeft,0,0);
   Control.TextShiftX := 1;
   Control.TextShiftY := 1;
   //Control.Style := Control.Style and not WS_BORDER;
   Control.OnBitBtnDraw := _OnDraw;
   //Control.Flat := true;
   Control.OnClick := _OnClick;
   //Control.Transparent := true;
   //Control.ExStyle := Control.ExStyle or WS_EX_TRANSPARENT;
   //Control.BitBtnImgList
end;
{
function THIBitBtn._onMessage;
var ps:TPaintStruct;
begin
   case Msg.message of
     WM_PAINT:
      begin
        BeginPaint(Control.Handle,ps);
        //Rectangle(ps.hdc,0,0,Control.Width,Control.Height);
        Result := false;
        EndPaint(Control.Handle,ps);
      end;
     else Result := inherited _onMessage(Msg,Rslt);
   end;
end;
}
procedure THIBitBtn._OnClick;
var dt:TData;
begin
   dt := _prop_Data;
   _hi_OnEvent(_event_onClick,dt);
end;

function THIBitBtn._OnDraw;
var r:TRect;
  procedure Fill;
  begin
   // if Control.Flat = false then
     with Control.Canvas{$ifndef F_P}^{$endif} do
      begin
       Brush.BrushStyle := bsSolid;
       Brush.Color := Control.Color;
       FillRect(r);
      end;
  end;
begin
   r := Control.ClientRect;
   Result := true;
   with Control.Canvas{$ifndef F_P}^{$endif} do
    case BtnState of
     0,2,3:     //normal;
        begin
          Fill;
          if Control.Flat then
           begin
            Pen.PenStyle := psSolid;
            Brush.BrushStyle := bsClear;
            if _prop_Frame = 0 then
             Pen.PenStyle := psSolid
            else Pen.PenStyle := psClear;
            Pen.Color := _prop_FrameColor;
            Rectangle(0,0,Control.Width,Control.Height);
           end
          else
            DrawFrameControl(Handle, r, DFC_BUTTON, DFCS_BUTTONPUSH or DFCS_TRANSPARENT);

          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX-1,FY-1);
          r.Left := -2;
          r.Top := -2;

          if not Control.Enabled then
           begin
             Font.Color := clWindow;
             inc(r.Top); inc(r.Left);
             inc(r.Bottom); inc(r.Right);
             DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);
             dec(r.Top);  dec(r.Left);
             dec(r.Bottom); dec(r.Right);
             Font.Color := clBtnShadow;
           end
          else Font.Color := _prop_Font.Color;
          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);
          //TextOut(25,Control.Height div 2 - 4,Control.Caption);
        end;
     40:
        begin
          Pen.Color := clActiveCaption;
          Fill;

          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX,FY);

          Brush.BrushStyle := bsClear;
          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);
          //TextOut(5,Control.Height div 2 - 4,Control.Caption);
        end;
     1:
        begin // down
          Fill;
          if Control.Flat then
           DrawEdge(Handle,r,BDR_SUNKENOUTER,BF_RECT)
          else
            DrawFrameControl(Handle, r, DFC_BUTTON, DFCS_BUTTONPUSH or DFCS_TRANSPARENT or DFCS_PUSHED);

          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX,FY);

          Brush.BrushStyle := bsClear;
          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);
        end;
     4:
        begin // select
          Fill;
          if Control.Flat then
            DrawEdge(Handle,r,BDR_RAISEDINNER,BF_RECT)
          else DrawFrameControl(Handle, r, DFC_BUTTON, DFCS_BUTTONPUSH or DFCS_TRANSPARENT);

          dec(r.Left,2); dec(r.top,2);
                             
          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX-1,FY-1);

          Brush.BrushStyle := bsClear;
          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);
        end;
     //else _debug(int2str(BtnState));
    end;
end;

procedure THIBitBtn._work_doCaption;
begin
   Control.Caption := ReadString(_data,null,'');
end;

procedure THIBitBtn.SetCaption;
begin
   Control.Caption := Value;
end;

procedure THIBitBtn.SetBitmap;
var c:TColor;
   i,j:word;
begin
   FBmp.Handle := Value;

   if FBmp.Width = 0 then exit;
   c := FBmp.Pixels[0,0];
   for i := 0 to FBmp.Width-1 do
    for j := 0 to FBmp.Height-1 do
     if FBmp.Pixels[i,j] = c then
      FBmp.Pixels[i,j] := clBtnFace;

   FY := _prop_Height div 2 - FBmp.Height div 2;
   if Control.Caption = '' then
       FX := _prop_Width div 2 - FBmp.Width div 2
   else FX := 3;
end;

procedure THIBitBtn.SetFlat;
begin
   Control.Flat := Value;
end;

procedure THIBitBtn._work_doBitmap;
var tmp:PBitmap;
begin
  tmp := ReadBitmap(_Data,_data_Bitmap,nil);
  if tmp <> nil then
     begin
       FBmp.Assign(tmp);
       Control.Invalidate;
     end;
end;

end.
